using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win.UltraWinEditors;

namespace WindowsControlLibrary1
{
    public partial class frmKanalauswahl : Form, IUIElementDrawFilter
    {
        DataSet dsKanle;
        UInt32 aktiveKanle = 255; // unchecked((UInt32)((UInt64)1 << 32) - 1);
        public void wcd(UInt32 uiNeuerWert)
        {
        }

        public frmKanalauswahl()
        {
            InitializeComponent();
            Datenaufbereiten();

        }

        private void DataSetErzeugen()
        {
            dsKanle = new DataSet("Kanle");
            dsKanle.Tables.Add("Tab1");
            DataTable tbl = dsKanle.Tables["Tab1"];
            tbl.Columns.Add(new DataColumn("SyncEintragIndex", typeof(UInt32)));
            tbl.Columns.Add(new DataColumn("SyncEintragNummer", typeof(UInt32)));
            tbl.Columns.Add(new DataColumn("ProgIndex", typeof(UInt32)));
            tbl.Columns.Add(new DataColumn("SatzIndex", typeof(UInt32)));
            tbl.Columns.Add(new DataColumn("FunktionsIndex", typeof(UInt32)));
            tbl.Columns.Add(new DataColumn("SyncEintragKanle", typeof(UInt32)));

        }
        private void EintragInTabelle(int p, int p_2, int p_3, int p_4, int p_5, int p_6)
        {
            dsKanle.Tables[0].Rows.Add(dsKanle.Tables[0].NewRow());
            dsKanle.Tables[0].Rows[dsKanle.Tables[0].Rows.Count - 1][0] = p;
            dsKanle.Tables[0].Rows[dsKanle.Tables[0].Rows.Count - 1][1] = p_2;
            dsKanle.Tables[0].Rows[dsKanle.Tables[0].Rows.Count - 1][2] = p_3;
            dsKanle.Tables[0].Rows[dsKanle.Tables[0].Rows.Count - 1][3] = p_4;
            dsKanle.Tables[0].Rows[dsKanle.Tables[0].Rows.Count - 1][4] = p_5;
            dsKanle.Tables[0].Rows[dsKanle.Tables[0].Rows.Count - 1][5] = p_6;
        }
        private void Datenaufbereiten()
        {
            DataSetErzeugen();
            ultraGrid1.DataSource = dsKanle;
            ultraGrid1.DataMember = "Tab1";
            this.ultraGrid1.DrawFilter = this;
            EintragInTabelle(1, 1, 1, 4, 3, 5344);
            EintragInTabelle(2, 2, 1, 5, 7, 0);
            EintragInTabelle(3, 3, 8, 4, 2, 1648);
            EintragInTabelle(4, 4, 8, 4, 4, 1327);
            EintragInTabelle(5, 5, 8, 4, 6, 192);
            EintragInTabelle(6, 6, 10, 1, 1, 15);
            EintragInTabelle(7, 7, 10, 3, 1, 255);
            EintragInTabelle(8, 8, 10, 5, 1, 65535);
        }


        UInt32? HchstesAngewhltesBit(UInt32 Bitkombination)
        {
            for (int i = 31; i > 0; i--)
            {
                if ((Bitkombination & ((uint)1 << i)) != 0)
                    return (UInt32?)i;
            }
            return null;
        }
        private Bitmap KanalBitmapErzeugen(UInt32? Bitkombination, int neueBreite, int neueHoehe)
        {
            int zwischenraum = 5;
            int rand = 5;
            UInt32 letzterKanal;
            if (aktiveKanle != 0)
                letzterKanal = 1 + (UInt32)HchstesAngewhltesBit(aktiveKanle);
            else
                letzterKanal = 0;

            float symbolbreite = (float)(neueBreite - 2.0f * rand - letzterKanal * zwischenraum) / letzterKanal;
            float symbolhhe = (float)neueHoehe - 2f * rand;


            if (symbolbreite < 16)
                symbolbreite = 16;
            if (symbolbreite > 32)
                symbolbreite = 32;
            if (symbolhhe < 16)
                symbolhhe = 16;
            if (symbolhhe > 32)
                symbolhhe = 32;

            // wenn die resultierende Breite oder Hhe grer ist als der zur Verfgung stehende Platz,
            // dann die Bitmapgre neu berechnen
            int maxbreite = (int)(rand + (int)(letzterKanal - 1) * (symbolbreite + zwischenraum) + symbolbreite + rand);
            int maxhhe = (int)(rand + symbolhhe + rand);
            Boolean bZuklein = false;
            //if (maxbreite > neueBreite)
            //{
            //    neueBreite = maxbreite;
            //    bZuklein = true;
            //}
            //if (maxhhe > neueHoehe)
            //{
            //    neueHoehe = maxhhe;
            //    bZuklein = true;
            //}

            neueHoehe = (int)(symbolhhe + 2 * rand);
            neueBreite = (int)(2 * rand + 32 * (symbolbreite + zwischenraum) - zwischenraum);

            Bitmap bmp = new Bitmap(neueBreite, neueHoehe);// new Bitmap(2 * rand + 32 * (breite + zwischenraum) - zwischenraum, 2 * rand + hoehe);
            Graphics gc = System.Drawing.Graphics.FromImage(bmp);

            Color Lschfarbe = Color.FromArgb(SystemColors.Control.ToArgb());
            gc.Clear(Lschfarbe);
            
            SolidBrush blackBrush = new SolidBrush(Color.Black);
            SolidBrush greenBrush = new SolidBrush(Color.Green);
            SolidBrush redBrush = new SolidBrush(Color.Red);
            SolidBrush whiteBrush = new SolidBrush(Color.White);
            SolidBrush yellowBrush = new SolidBrush(Color.Yellow);
            
            Font schriftfont = new Font(Font.FontFamily, 8.25F);
            for (int i = 0; i < 32; i++)
            {
                int x1 = (int)(rand + i * (symbolbreite + zwischenraum));
                int y1 = rand;

                if ((aktiveKanle & (1 << i)) != 0)
                {
                    gc.DrawRectangle(new Pen(Color.Black), x1, y1, symbolbreite, symbolhhe);
                    if ((Bitkombination & (1 << i)) != 0)
                    {
                        gc.FillRectangle(yellowBrush, new Rectangle(x1 + 1, y1 + 1, (int)symbolbreite - 2, (int)symbolhhe - 2));
                        gc.DrawString(String.Format("{0}", i + 1), ultraGrid1.Font, blackBrush, x1 + 1, y1 + 1);
                    }
                    else
                    {
                        gc.FillRectangle(whiteBrush, new Rectangle(x1 + 1, y1 + 1, (int)symbolbreite - 2, (int)symbolhhe - 2));
                        gc.DrawString(String.Format("{0}", i + 1), schriftfont, blackBrush, x1 + 1, y1 + 1);
                    }
                }
                else
                    ;
            }
            // gc.DrawRectangle(new Pen(Color.Black), rand, rand, maxbreite - rand * 2, maxhhe - rand * 2);
            return bmp;
        }


        #region Grid Darstellung einstellen
        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.AutoFitStyle = AutoFitStyle.None;
            if (!e.Layout.Bands[0].Columns.Exists("SynchronisationsFunktion"))
            {
                e.Layout.Bands[0].Columns.Add("SynchronisationsFunktion");
                e.Layout.Bands[0].Columns["SynchronisationsFunktion"].DataType = typeof(String);
            }
            if (!e.Layout.Bands[0].Columns.Exists("Kanle zum Synchronisieren"))
            {
                e.Layout.Bands[0].Columns.Add("Kanle zum Synchronisieren");
                e.Layout.Bands[0].Columns["Kanle zum Synchronisieren"].DataType = typeof(String);
            }
            foreach (UltraGridColumn col in e.Layout.Bands[0].Columns)
            {
                col.Hidden = true;
            }
            e.Layout.Bands[0].Columns["SynchronisationsFunktion"].Hidden = false;
            e.Layout.Bands[0].Columns["Kanle zum Synchronisieren"].Hidden = false;

            e.Layout.Bands[0].Columns["Kanle zum Synchronisieren"].AutoSizeMode = ColumnAutoSizeMode.AllRowsInBand;
            e.Layout.Bands[0].Columns["Kanle zum Synchronisieren"].Width = 150;
            e.Layout.Bands[0].Columns["Kanle zum Synchronisieren"].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.DropDownList;
            e.Layout.Bands[0].Columns["Kanle zum Synchronisieren"].Layout.Appearance.ImageHAlign = HAlign.Left;
            e.Layout.Bands[0].Columns["Kanle zum Synchronisieren"].Layout.Appearance.ImageVAlign = VAlign.Top;
            e.Layout.Bands[0].Columns["Kanle zum Synchronisieren"].Layout.Appearance.ImageBackgroundOrigin = ImageBackgroundOrigin.Relative;
            e.Layout.Bands[0].Columns["Kanle zum Synchronisieren"].Layout.Appearance.TextHAlign = HAlign.Left;
            e.Layout.Bands[0].Columns["Kanle zum Synchronisieren"].Layout.Appearance.TextVAlign = VAlign.Top;
            e.Layout.Bands[0].Columns["Kanle zum Synchronisieren"].Layout.Appearance.ImageBackgroundStyle = ImageBackgroundStyle.Default;
            EditorWithCombo ewc = new EditorWithCombo();
            ewc.ButtonDisplayStyle = Infragistics.Win.ButtonDisplayStyle.Never;
            DropDownEditorButton ddew = new DropDownEditorButton("Kanaele");
            ddew.Control = kanalauswahl1;

            ewc.ButtonsRight.Add(ddew);
            ewc.BeforeEditorButtonDropDown += new BeforeEditorButtonDropDownEventHandler(ewc_BeforeEditorButtonDropDown);
            ewc.AfterEditorButtonCloseUp += new EditorButtonEventHandler(ewc_AfterEditorButtonCloseUp);
            e.Layout.Bands[0].Columns["Kanle zum Synchronisieren"].Editor = ewc;
        }
        private void ultraGrid1_InitializeRow(object sender, InitializeRowEventArgs e)
        {
            if (e.Row.IsTemplateAddRow)
                return;

            //             e.Row.Cells["Kanle zum Synchronisieren"].Appearance.Image = KanalBitmapErzeugen(Convert.ToUInt32(e.Row.Cells["SyncEintragKanle"].Value), e.Row.Cells["SyncEintragKanle"].Column.CalculateAutoResizeWidth(PerformAutoSizeType.None, true), e.Row.Cells["SyncEintragKanle"].Height);
            e.Row.Cells["SynchronisationsFunktion"].Value = String.Format("P{0}.S{1}.F{2}", e.Row.Cells[2].Value, e.Row.Cells[3].Value, e.Row.Cells[4].Value);

        }
        #endregion Grid Darstellung einstellen
        #region DropdownButton fr Kanalauswahl
        void ewc_AfterEditorButtonCloseUp(object sender, EditorButtonEventArgs e)
        {
            ultraGrid1.ActiveCell.Row.Cells[5].Value = kanalauswahl1.Wert;

        }

        void ewc_BeforeEditorButtonDropDown(object sender, BeforeEditorButtonDropDownEventArgs e)
        {
            if (e.Button.Key == "Kanaele" && ultraGrid1.ActiveCell != null)
            {
                // Hier jetzt aus der Zahl eine Auswahl in der CheckedListbox setzen
                if (ultraGrid1.ActiveCell.Row.Cells[5].Value != DBNull.Value)
                {
                    UInt32 kanalauswahl = Convert.ToUInt32(ultraGrid1.ActiveCell.Row.Cells[5].Value);
                    kanalauswahl1.Wert = kanalauswahl;
                }
                else
                    kanalauswahl1.Wert = 0;
                //kanalauswahl1.Rand = 8;
                //kanalauswahl1.Breite = 32;
                //kanalauswahl1.Hhe = 24;
                //kanalauswahl1.Zwischenraum = 1;
                //kanalauswahl1.Width = 443;
                //kanalauswahl1.Height = 377;
            }
        }
        #endregion DropdownButton fr Kanalauswahl

        private void ultraGrid1_AfterCellActivate(object sender, EventArgs e)
        {
            UltraGrid grid = (UltraGrid)sender;
            UltraGridCell cell = grid.ActiveCell;
            if (cell.Column.Index == 7)
            {
                grid.PerformAction(UltraGridAction.EnterEditMode);
                EmbeddableEditorButtonBase embeddableEditorButtonBase = cell.EditorResolved as EmbeddableEditorButtonBase;
                DropDownEditorButton dropdownEditorButton = embeddableEditorButtonBase.ButtonsRight[0] as DropDownEditorButton;
                dropdownEditorButton.DropDown();
                kanalauswahl1.button = dropdownEditorButton;
            }
        }

        #region IUIElementDrawFilter Member

        public bool DrawElement(DrawPhase drawPhase, ref UIElementDrawParams drawParams)
        {
            CellUIElement cellUIElement;
            UltraGrid objGrid;
            UltraGridRow objRow;
            Image objImage;

            switch (drawPhase)
            {
                case Infragistics.Win.DrawPhase.AfterDrawChildElements:
                    //Get the ImageUIElement
                    cellUIElement = (CellUIElement)drawParams.Element;

                    //Get a reference to the grid control. This is only necessary in
                    //order to get the ImageList. If you are using images from somewhere
                    //else, you do not need this line.
                    objGrid = (UltraGrid)cellUIElement.Control;

                    //Get the row we are dealing with.
                    objRow = (UltraGridRow)cellUIElement.GetContext(typeof(UltraGridRow));
                    //Get the image related with this row.
                    objImage = KanalBitmapErzeugen((uint?)objRow.Cells["SyncEintragKanle"].Value, drawParams.Element.Rect.Width-32, drawParams.Element.Rect.Height);

                    //drawParams.AppearanceData.Image = objImage;
                    //progressBar.DrawToGraphics(drawParams.Graphics);
                    Rectangle neuesRect = drawParams.Element.Rect;
                    if (drawParams.Element.Rect.Height >= objImage.Height)
                    {
                        int yNeu = (drawParams.Element.Rect.Height / 2) - (objImage.Height / 2);
                        yNeu += drawParams.Element.Rect.Y;
                        neuesRect.Y = yNeu;
                    }
                    neuesRect.X += 16;
                    //if (objImage.Width +16 < neuesRect.Width)
                    //    neuesRect.Width = objImage.Width+16;
                    if (objImage.Height < neuesRect.Height)
                        neuesRect.Height = objImage.Height;
                    if (objImage.Width > drawParams.Element.Rect.Width - 32)
                        neuesRect.Width = drawParams.Element.Rect.Width - 32;
                    else
                        neuesRect.Width = objImage.Width;
                    drawParams.Graphics.DrawImageUnscaledAndClipped(objImage, neuesRect);
                    // drawParams.DrawImage(objImage, drawParams.Element.Rect, false, null);
                    return false;
            }
            return false;
        }

        public DrawPhase GetPhasesToFilter(ref UIElementDrawParams drawParams)
        {
            UltraGridCell cell = (UltraGridCell)drawParams.Element.GetContext(typeof(UltraGridCell));
            if (cell != null && cell.Column.ToString() == "Kanle zum Synchronisieren")
                if (drawParams.Element is CellUIElement)
                    return DrawPhase.AfterDrawChildElements;
            return DrawPhase.None;
        }

        #endregion
    }
}
